﻿using Microsoft.AspNet.Identity;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Threading.Tasks;
using CommunityDays2014Milano.Advanced.DAL;
using System.Data.Entity;

namespace CommunityDays2014Milano.Advanced.Security
{
    public class MyUserStore : IUserPasswordStore<MyUser>
    {
        IDataStore dataStore = null;

        public MyUserStore()
        {
            this.dataStore = new DataStore();
        }

        public async Task<string> GetPasswordHashAsync(MyUser user)
        {
            var password = await this.dataStore.Users
                .Where(x => x.UserName == user.UserName)
                .Select(x => x.Password).SingleOrDefaultAsync();

            PasswordHasher hasher = new PasswordHasher();
            return hasher.HashPassword(password);
        }

        public Task<bool> HasPasswordAsync(MyUser user)
        {
            throw new NotImplementedException();
        }

        public Task SetPasswordHashAsync(MyUser user, string passwordHash)
        {
            throw new NotImplementedException();
        }

        public Task CreateAsync(MyUser user)
        {
            throw new NotImplementedException();
        }

        public Task DeleteAsync(MyUser user)
        {
            throw new NotImplementedException();
        }

        public Task<MyUser> FindByIdAsync(string userId)
        {
            throw new NotImplementedException();
        }

        public Task<MyUser> FindByNameAsync(string userName)
        {
            return this.dataStore.Users
                .Where(x => x.UserName == userName)
                .Select(x => new MyUser()
                {
                    Id = x.UserName,
                    UserName = x.UserName,
                    FirstName = x.FirstName,
                    LastName = x.LastName
                }).SingleOrDefaultAsync();
        }

        public Task UpdateAsync(MyUser user)
        {
            throw new NotImplementedException();
        }

        public void Dispose()
        {
            throw new NotImplementedException();
        }
    }
}